Linus Torvalds | 839a7a0 | 2005-04-18 12:15:10 -0700 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # |
Junio C Hamano | 521003f | 2005-08-22 21:57:59 -0700 | [diff] [blame] | 3 | # Copyright (c) 2005 Junio C Hamano |
| 4 | # |
| 5 | # Fetch one or more remote refs and merge it/them into the current HEAD. |
| 6 | |
SZEDER Gábor | d8abe14 | 2008-04-06 03:23:43 +0200 | [diff] [blame] | 7 | USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...' |
freku045@student.liu.se | 806f36d | 2005-12-13 23:30:31 +0100 | [diff] [blame] | 8 | LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.' |
Junio C Hamano | 533b703 | 2007-01-12 12:52:03 -0800 | [diff] [blame] | 9 | SUBDIRECTORY_OK=Yes |
Junio C Hamano | 8f321a3 | 2007-11-06 01:50:02 -0800 | [diff] [blame] | 10 | OPTIONS_SPEC= |
Junio C Hamano | ae2b0f1 | 2005-11-24 00:12:11 -0800 | [diff] [blame] | 11 | . git-sh-setup |
Ævar Arnfjörð Bjarmason | a9f5786 | 2011-05-21 18:43:54 +0000 | [diff] [blame] | 12 | . git-sh-i18n |
Ori Avtalion | c98d1e4 | 2011-07-29 10:19:26 +0300 | [diff] [blame] | 13 | set_reflog_action "pull${1+ $*}" |
Jeff King | 035b5bf | 2011-10-13 11:59:24 -0400 | [diff] [blame] | 14 | require_work_tree_exists |
Junio C Hamano | 533b703 | 2007-01-12 12:52:03 -0800 | [diff] [blame] | 15 | cd_to_toplevel |
Junio C Hamano | b10ac50 | 2005-08-25 18:15:32 -0700 | [diff] [blame] | 16 | |
Matthieu Moy | d38a30d | 2010-01-12 10:54:44 +0100 | [diff] [blame] | 17 | |
| 18 | die_conflict () { |
| 19 | git diff-index --cached --name-status -r --ignore-submodules HEAD -- |
| 20 | if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then |
Ævar Arnfjörð Bjarmason | 85af5f8 | 2011-05-21 18:43:55 +0000 | [diff] [blame] | 21 | die "$(gettext "Pull is not possible because you have unmerged files. |
Matthieu Moy | d38a30d | 2010-01-12 10:54:44 +0100 | [diff] [blame] | 22 | Please, fix them up in the work tree, and then use 'git add/rm <file>' |
Ævar Arnfjörð Bjarmason | 85af5f8 | 2011-05-21 18:43:55 +0000 | [diff] [blame] | 23 | as appropriate to mark resolution, or use 'git commit -a'.")" |
Matthieu Moy | d38a30d | 2010-01-12 10:54:44 +0100 | [diff] [blame] | 24 | else |
Ævar Arnfjörð Bjarmason | 85af5f8 | 2011-05-21 18:43:55 +0000 | [diff] [blame] | 25 | die "$(gettext "Pull is not possible because you have unmerged files.")" |
Matthieu Moy | d38a30d | 2010-01-12 10:54:44 +0100 | [diff] [blame] | 26 | fi |
| 27 | } |
| 28 | |
| 29 | die_merge () { |
| 30 | if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then |
Ævar Arnfjörð Bjarmason | 85af5f8 | 2011-05-21 18:43:55 +0000 | [diff] [blame] | 31 | die "$(gettext "You have not concluded your merge (MERGE_HEAD exists). |
| 32 | Please, commit your changes before you can merge.")" |
Matthieu Moy | d38a30d | 2010-01-12 10:54:44 +0100 | [diff] [blame] | 33 | else |
Ævar Arnfjörð Bjarmason | 85af5f8 | 2011-05-21 18:43:55 +0000 | [diff] [blame] | 34 | die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")" |
Matthieu Moy | d38a30d | 2010-01-12 10:54:44 +0100 | [diff] [blame] | 35 | fi |
| 36 | } |
| 37 | |
| 38 | test -z "$(git ls-files -u)" || die_conflict |
| 39 | test -f "$GIT_DIR/MERGE_HEAD" && die_merge |
Junio C Hamano | d1014a1 | 2006-12-31 23:21:50 -0800 | [diff] [blame] | 40 | |
Björn Gustavsson | 1347483 | 2009-10-29 23:08:31 +0100 | [diff] [blame] | 41 | strategy_args= diffstat= no_commit= squash= no_ff= ff_only= |
Jens Lehmann | 7dce19d | 2010-11-12 13:54:52 +0100 | [diff] [blame] | 42 | log_arg= verbosity= progress= recurse_submodules= |
Linus Torvalds | 8580830 | 2012-02-11 10:21:03 -0800 | [diff] [blame] | 43 | merge_args= edit= |
Johannes Schindelin | cd67e4d | 2007-11-28 13:11:07 +0000 | [diff] [blame] | 44 | curr_branch=$(git symbolic-ref -q HEAD) |
Stephen Boyd | 0d12e59 | 2010-03-17 22:10:45 -0700 | [diff] [blame] | 45 | curr_branch_short="${curr_branch#refs/heads/}" |
Johannes Schindelin | cd67e4d | 2007-11-28 13:11:07 +0000 | [diff] [blame] | 46 | rebase=$(git config --bool branch.$curr_branch_short.rebase) |
Ævar Arnfjörð Bjarmason | 6b37dff | 2011-11-06 10:50:10 +0100 | [diff] [blame] | 47 | if test -z "$rebase" |
| 48 | then |
| 49 | rebase=$(git config --bool pull.rebase) |
| 50 | fi |
Jeff King | 29609e6 | 2010-05-25 02:07:25 -0400 | [diff] [blame] | 51 | dry_run= |
David Kastrup | 822f7c7 | 2007-09-23 22:42:08 +0200 | [diff] [blame] | 52 | while : |
Junio C Hamano | 60fb5b2 | 2005-09-25 19:43:51 -0700 | [diff] [blame] | 53 | do |
| 54 | case "$1" in |
Tuncer Ayaz | 7f87aff | 2008-11-15 01:14:24 +0100 | [diff] [blame] | 55 | -q|--quiet) |
Tuncer Ayaz | c6576f9 | 2008-11-17 23:09:30 +0100 | [diff] [blame] | 56 | verbosity="$verbosity -q" ;; |
Tuncer Ayaz | 7f87aff | 2008-11-15 01:14:24 +0100 | [diff] [blame] | 57 | -v|--verbose) |
Tuncer Ayaz | c6576f9 | 2008-11-17 23:09:30 +0100 | [diff] [blame] | 58 | verbosity="$verbosity -v" ;; |
Tay Ray Chuan | 9839018 | 2010-02-24 20:50:28 +0800 | [diff] [blame] | 59 | --progress) |
| 60 | progress=--progress ;; |
Jeff King | bebd2fd | 2011-02-20 04:56:56 -0500 | [diff] [blame] | 61 | --no-progress) |
| 62 | progress=--no-progress ;; |
SZEDER Gábor | d8abe14 | 2008-04-06 03:23:43 +0200 | [diff] [blame] | 63 | -n|--no-stat|--no-summary) |
Tor Arne Vestbø | a334e12 | 2009-03-01 22:28:28 +0100 | [diff] [blame] | 64 | diffstat=--no-stat ;; |
SZEDER Gábor | d8abe14 | 2008-04-06 03:23:43 +0200 | [diff] [blame] | 65 | --stat|--summary) |
Tor Arne Vestbø | a334e12 | 2009-03-01 22:28:28 +0100 | [diff] [blame] | 66 | diffstat=--stat ;; |
SZEDER Gábor | efb779f | 2008-04-06 03:23:46 +0200 | [diff] [blame] | 67 | --log|--no-log) |
| 68 | log_arg=$1 ;; |
Junio C Hamano | 123ee3c | 2005-11-01 19:30:11 -0800 | [diff] [blame] | 69 | --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit) |
| 70 | no_commit=--no-commit ;; |
Lars Hjemli | 5072a32 | 2007-10-29 09:41:18 +0100 | [diff] [blame] | 71 | --c|--co|--com|--comm|--commi|--commit) |
| 72 | no_commit=--commit ;; |
Linus Torvalds | 8580830 | 2012-02-11 10:21:03 -0800 | [diff] [blame] | 73 | -e|--edit) |
| 74 | edit=--edit ;; |
| 75 | --no-edit) |
| 76 | edit=--no-edit ;; |
Junio C Hamano | 7d0c688 | 2006-06-23 01:37:02 -0700 | [diff] [blame] | 77 | --sq|--squ|--squa|--squas|--squash) |
| 78 | squash=--squash ;; |
Lars Hjemli | 5072a32 | 2007-10-29 09:41:18 +0100 | [diff] [blame] | 79 | --no-sq|--no-squ|--no-squa|--no-squas|--no-squash) |
| 80 | squash=--no-squash ;; |
| 81 | --ff) |
| 82 | no_ff=--ff ;; |
| 83 | --no-ff) |
| 84 | no_ff=--no-ff ;; |
Björn Gustavsson | 1347483 | 2009-10-29 23:08:31 +0100 | [diff] [blame] | 85 | --ff-only) |
| 86 | ff_only=--ff-only ;; |
Junio C Hamano | 60fb5b2 | 2005-09-25 19:43:51 -0700 | [diff] [blame] | 87 | -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\ |
| 88 | --strateg=*|--strategy=*|\ |
| 89 | -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy) |
| 90 | case "$#,$1" in |
| 91 | *,*=*) |
Dennis Stosberg | 8096fae | 2006-06-27 18:54:26 +0200 | [diff] [blame] | 92 | strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;; |
Junio C Hamano | 60fb5b2 | 2005-09-25 19:43:51 -0700 | [diff] [blame] | 93 | 1,*) |
| 94 | usage ;; |
| 95 | *) |
| 96 | strategy="$2" |
| 97 | shift ;; |
| 98 | esac |
| 99 | strategy_args="${strategy_args}-s $strategy " |
| 100 | ;; |
Avery Pennarun | ee2c795 | 2009-11-25 21:23:57 -0500 | [diff] [blame] | 101 | -X*) |
| 102 | case "$#,$1" in |
| 103 | 1,-X) |
| 104 | usage ;; |
| 105 | *,-X) |
Junio C Hamano | 14e5d40 | 2010-01-17 22:31:38 -0800 | [diff] [blame] | 106 | xx="-X $(git rev-parse --sq-quote "$2")" |
Avery Pennarun | ee2c795 | 2009-11-25 21:23:57 -0500 | [diff] [blame] | 107 | shift ;; |
| 108 | *,*) |
Junio C Hamano | 14e5d40 | 2010-01-17 22:31:38 -0800 | [diff] [blame] | 109 | xx=$(git rev-parse --sq-quote "$1") ;; |
Avery Pennarun | ee2c795 | 2009-11-25 21:23:57 -0500 | [diff] [blame] | 110 | esac |
| 111 | merge_args="$merge_args$xx " |
| 112 | ;; |
Johannes Schindelin | cd67e4d | 2007-11-28 13:11:07 +0000 | [diff] [blame] | 113 | -r|--r|--re|--reb|--reba|--rebas|--rebase) |
| 114 | rebase=true |
| 115 | ;; |
| 116 | --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase) |
| 117 | rebase=false |
| 118 | ;; |
Jens Lehmann | 7dce19d | 2010-11-12 13:54:52 +0100 | [diff] [blame] | 119 | --recurse-submodules) |
| 120 | recurse_submodules=--recurse-submodules |
| 121 | ;; |
Jens Lehmann | 8f0700d | 2011-03-06 23:11:21 +0100 | [diff] [blame] | 122 | --recurse-submodules=*) |
| 123 | recurse_submodules="$1" |
| 124 | ;; |
Jens Lehmann | be254a0 | 2010-11-11 00:55:02 +0100 | [diff] [blame] | 125 | --no-recurse-submodules) |
| 126 | recurse_submodules=--no-recurse-submodules |
| 127 | ;; |
Jeff King | 29609e6 | 2010-05-25 02:07:25 -0400 | [diff] [blame] | 128 | --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run) |
| 129 | dry_run=--dry-run |
| 130 | ;; |
Clemens Buchacher | 87182b1 | 2011-10-03 20:21:36 +0200 | [diff] [blame] | 131 | -h|--help-all) |
Jon Loeliger | 93d69d8 | 2005-11-06 23:30:56 -0600 | [diff] [blame] | 132 | usage |
| 133 | ;; |
David Kastrup | 822f7c7 | 2007-09-23 22:42:08 +0200 | [diff] [blame] | 134 | *) |
| 135 | # Pass thru anything that may be meant for fetch. |
Junio C Hamano | 619e5a0 | 2005-10-03 15:45:44 -0700 | [diff] [blame] | 136 | break |
Junio C Hamano | 60fb5b2 | 2005-09-25 19:43:51 -0700 | [diff] [blame] | 137 | ;; |
| 138 | esac |
| 139 | shift |
| 140 | done |
| 141 | |
Junio C Hamano | 441ed41 | 2007-12-28 13:58:43 -0800 | [diff] [blame] | 142 | error_on_no_merge_candidates () { |
| 143 | exec >&2 |
| 144 | for opt |
| 145 | do |
| 146 | case "$opt" in |
| 147 | -t|--t|--ta|--tag|--tags) |
| 148 | echo "Fetching tags only, you probably meant:" |
| 149 | echo " git fetch --tags" |
| 150 | exit 1 |
| 151 | esac |
| 152 | done |
| 153 | |
Jan Krüger | 995fc2f | 2009-11-27 08:17:05 -0600 | [diff] [blame] | 154 | if test true = "$rebase" |
| 155 | then |
| 156 | op_type=rebase |
| 157 | op_prep=against |
| 158 | else |
| 159 | op_type=merge |
| 160 | op_prep=with |
| 161 | fi |
| 162 | |
Junio C Hamano | 441ed41 | 2007-12-28 13:58:43 -0800 | [diff] [blame] | 163 | curr_branch=${curr_branch#refs/heads/} |
Junio C Hamano | a6dbf88 | 2009-09-13 13:38:48 -0700 | [diff] [blame] | 164 | upstream=$(git config "branch.$curr_branch.merge") |
Jeff King | a8c9bef | 2009-10-05 15:35:16 -0400 | [diff] [blame] | 165 | remote=$(git config "branch.$curr_branch.remote") |
Junio C Hamano | 441ed41 | 2007-12-28 13:58:43 -0800 | [diff] [blame] | 166 | |
Jeff King | a8c9bef | 2009-10-05 15:35:16 -0400 | [diff] [blame] | 167 | if [ $# -gt 1 ]; then |
Jan Krüger | 995fc2f | 2009-11-27 08:17:05 -0600 | [diff] [blame] | 168 | if [ "$rebase" = true ]; then |
| 169 | printf "There is no candidate for rebasing against " |
| 170 | else |
| 171 | printf "There are no candidates for merging " |
| 172 | fi |
| 173 | echo "among the refs that you just fetched." |
Jeff King | a8c9bef | 2009-10-05 15:35:16 -0400 | [diff] [blame] | 174 | echo "Generally this means that you provided a wildcard refspec which had no" |
| 175 | echo "matches on the remote end." |
| 176 | elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then |
| 177 | echo "You asked to pull from the remote '$1', but did not specify" |
Jan Krüger | 995fc2f | 2009-11-27 08:17:05 -0600 | [diff] [blame] | 178 | echo "a branch. Because this is not the default configured remote" |
Jeff King | a8c9bef | 2009-10-05 15:35:16 -0400 | [diff] [blame] | 179 | echo "for your current branch, you must specify a branch on the command line." |
Martin von Zweigbergk | 15a147e | 2011-02-09 20:54:02 -0500 | [diff] [blame] | 180 | elif [ -z "$curr_branch" -o -z "$upstream" ]; then |
| 181 | . git-parse-remote |
| 182 | error_on_missing_default_upstream "pull" $op_type $op_prep \ |
Carlos Martín Nieto | 3c02396 | 2012-03-04 05:41:26 +0100 | [diff] [blame] | 183 | "git pull <remote> <branch>" |
Junio C Hamano | a6dbf88 | 2009-09-13 13:38:48 -0700 | [diff] [blame] | 184 | else |
Jan Krüger | 995fc2f | 2009-11-27 08:17:05 -0600 | [diff] [blame] | 185 | echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'" |
| 186 | echo "from the remote, but no such ref was fetched." |
Matthieu Moy | 61e6108 | 2009-04-08 09:24:03 +0200 | [diff] [blame] | 187 | fi |
Junio C Hamano | 441ed41 | 2007-12-28 13:58:43 -0800 | [diff] [blame] | 188 | exit 1 |
| 189 | } |
| 190 | |
Johannes Schindelin | c85c792 | 2008-01-26 18:04:37 +0000 | [diff] [blame] | 191 | test true = "$rebase" && { |
Jeff King | 19a7fcb | 2009-08-11 23:27:40 -0400 | [diff] [blame] | 192 | if ! git rev-parse -q --verify HEAD >/dev/null |
| 193 | then |
| 194 | # On an unborn branch |
| 195 | if test -f "$GIT_DIR/index" |
| 196 | then |
Ævar Arnfjörð Bjarmason | 85af5f8 | 2011-05-21 18:43:55 +0000 | [diff] [blame] | 197 | die "$(gettext "updating an unborn branch with changes added to the index")" |
Jeff King | 19a7fcb | 2009-08-11 23:27:40 -0400 | [diff] [blame] | 198 | fi |
| 199 | else |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 200 | require_clean_work_tree "pull with rebase" "Please commit or stash them." |
Jeff King | 19a7fcb | 2009-08-11 23:27:40 -0400 | [diff] [blame] | 201 | fi |
Santi Béjar | d44e712 | 2009-07-19 09:45:16 +0200 | [diff] [blame] | 202 | oldremoteref= && |
Johannes Schindelin | c85c792 | 2008-01-26 18:04:37 +0000 | [diff] [blame] | 203 | . git-parse-remote && |
Santi Béjar | d44e712 | 2009-07-19 09:45:16 +0200 | [diff] [blame] | 204 | remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" && |
| 205 | oldremoteref="$(git rev-parse -q --verify "$remoteref")" && |
| 206 | for reflog in $(git rev-list -g $remoteref 2>/dev/null) |
| 207 | do |
| 208 | if test "$reflog" = "$(git merge-base $reflog $curr_branch)" |
| 209 | then |
| 210 | oldremoteref="$reflog" |
| 211 | break |
| 212 | fi |
| 213 | done |
Johannes Schindelin | c85c792 | 2008-01-26 18:04:37 +0000 | [diff] [blame] | 214 | } |
Miklos Vajna | 2d17985 | 2008-12-03 14:26:50 +0100 | [diff] [blame] | 215 | orig_head=$(git rev-parse -q --verify HEAD) |
Jens Lehmann | 7dce19d | 2010-11-12 13:54:52 +0100 | [diff] [blame] | 216 | git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1 |
Jeff King | 29609e6 | 2010-05-25 02:07:25 -0400 | [diff] [blame] | 217 | test -z "$dry_run" || exit 0 |
Junio C Hamano | b10ac50 | 2005-08-25 18:15:32 -0700 | [diff] [blame] | 218 | |
Miklos Vajna | 2d17985 | 2008-12-03 14:26:50 +0100 | [diff] [blame] | 219 | curr_head=$(git rev-parse -q --verify HEAD) |
Junio C Hamano | b0ad11e | 2008-10-14 15:32:20 -0700 | [diff] [blame] | 220 | if test -n "$orig_head" && test "$curr_head" != "$orig_head" |
Junio C Hamano | b10ac50 | 2005-08-25 18:15:32 -0700 | [diff] [blame] | 221 | then |
| 222 | # The fetch involved updating the current branch. |
| 223 | |
| 224 | # The working tree and the index file is still based on the |
| 225 | # $orig_head commit, but we are merging into $curr_head. |
| 226 | # First update the working tree to match $curr_head. |
| 227 | |
Jon Seymour | c2b1a95 | 2011-08-07 21:58:15 +1000 | [diff] [blame] | 228 | eval_gettextln "Warning: fetch updated the current branch head. |
Ævar Arnfjörð Bjarmason | 3320a97 | 2011-05-21 18:43:57 +0000 | [diff] [blame] | 229 | Warning: fast-forwarding your working tree from |
Jon Seymour | c2b1a95 | 2011-08-07 21:58:15 +1000 | [diff] [blame] | 230 | Warning: commit \$orig_head." >&2 |
Dan Loewenherz | 7bd93c1 | 2009-04-22 21:46:02 -0400 | [diff] [blame] | 231 | git update-index -q --refresh |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 232 | git read-tree -u -m "$orig_head" "$curr_head" || |
Ævar Arnfjörð Bjarmason | 9f35aaa | 2011-05-21 18:43:56 +0000 | [diff] [blame] | 233 | die "$(eval_gettext "Cannot fast-forward your working tree. |
Junio C Hamano | 8323124 | 2006-03-22 01:57:11 -0800 | [diff] [blame] | 234 | After making sure that you saved anything precious from |
Ævar Arnfjörð Bjarmason | 9f35aaa | 2011-05-21 18:43:56 +0000 | [diff] [blame] | 235 | $ git diff \$orig_head |
Junio C Hamano | 8323124 | 2006-03-22 01:57:11 -0800 | [diff] [blame] | 236 | output, run |
| 237 | $ git reset --hard |
Ævar Arnfjörð Bjarmason | 9f35aaa | 2011-05-21 18:43:56 +0000 | [diff] [blame] | 238 | to recover.")" |
Junio C Hamano | 8323124 | 2006-03-22 01:57:11 -0800 | [diff] [blame] | 239 | |
Junio C Hamano | b10ac50 | 2005-08-25 18:15:32 -0700 | [diff] [blame] | 240 | fi |
| 241 | |
Junio C Hamano | 05dd8e2 | 2005-09-25 22:54:23 -0700 | [diff] [blame] | 242 | merge_head=$(sed -e '/ not-for-merge /d' \ |
| 243 | -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \ |
| 244 | tr '\012' ' ') |
Junio C Hamano | e0bfc81 | 2005-08-20 02:57:26 -0700 | [diff] [blame] | 245 | |
| 246 | case "$merge_head" in |
Junio C Hamano | 521003f | 2005-08-22 21:57:59 -0700 | [diff] [blame] | 247 | '') |
Junio C Hamano | 4973aa2 | 2009-10-05 12:03:25 -0700 | [diff] [blame] | 248 | error_on_no_merge_candidates "$@" |
Junio C Hamano | 521003f | 2005-08-22 21:57:59 -0700 | [diff] [blame] | 249 | ;; |
Junio C Hamano | 60fb5b2 | 2005-09-25 19:43:51 -0700 | [diff] [blame] | 250 | ?*' '?*) |
Linus Torvalds | d09e79c | 2006-11-16 11:47:22 -0800 | [diff] [blame] | 251 | if test -z "$orig_head" |
| 252 | then |
Ævar Arnfjörð Bjarmason | 85af5f8 | 2011-05-21 18:43:55 +0000 | [diff] [blame] | 253 | die "$(gettext "Cannot merge multiple branches into empty head")" |
Linus Torvalds | d09e79c | 2006-11-16 11:47:22 -0800 | [diff] [blame] | 254 | fi |
Jay Soffian | 51b2ead | 2009-02-18 08:44:02 -0500 | [diff] [blame] | 255 | if test true = "$rebase" |
| 256 | then |
Ævar Arnfjörð Bjarmason | 85af5f8 | 2011-05-21 18:43:55 +0000 | [diff] [blame] | 257 | die "$(gettext "Cannot rebase onto multiple branches")" |
Jay Soffian | 51b2ead | 2009-02-18 08:44:02 -0500 | [diff] [blame] | 258 | fi |
Junio C Hamano | 60fb5b2 | 2005-09-25 19:43:51 -0700 | [diff] [blame] | 259 | ;; |
| 260 | esac |
| 261 | |
Linus Torvalds | d09e79c | 2006-11-16 11:47:22 -0800 | [diff] [blame] | 262 | if test -z "$orig_head" |
| 263 | then |
Junio C Hamano | b0ad11e | 2008-10-14 15:32:20 -0700 | [diff] [blame] | 264 | git update-ref -m "initial pull" HEAD $merge_head "$curr_head" && |
Jeff King | 4b3ffe5 | 2011-03-25 14:13:31 -0400 | [diff] [blame] | 265 | git read-tree -m -u HEAD || exit 1 |
Linus Torvalds | d09e79c | 2006-11-16 11:47:22 -0800 | [diff] [blame] | 266 | exit |
| 267 | fi |
| 268 | |
Elijah Newren | cf65426 | 2010-08-12 19:50:50 -0600 | [diff] [blame] | 269 | if test true = "$rebase" |
| 270 | then |
| 271 | o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref) |
| 272 | if test "$oldremoteref" = "$o" |
| 273 | then |
| 274 | unset oldremoteref |
| 275 | fi |
| 276 | fi |
| 277 | |
SZEDER Gábor | efb779f | 2008-04-06 03:23:46 +0200 | [diff] [blame] | 278 | merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit |
Junio C Hamano | 14e5d40 | 2010-01-17 22:31:38 -0800 | [diff] [blame] | 279 | case "$rebase" in |
| 280 | true) |
| 281 | eval="git-rebase $diffstat $strategy_args $merge_args" |
| 282 | eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}" |
| 283 | ;; |
| 284 | *) |
Linus Torvalds | 8580830 | 2012-02-11 10:21:03 -0800 | [diff] [blame] | 285 | eval="git-merge $diffstat $no_commit $edit $squash $no_ff $ff_only" |
Jeff King | bebd2fd | 2011-02-20 04:56:56 -0500 | [diff] [blame] | 286 | eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress" |
| 287 | eval="$eval \"\$merge_name\" HEAD $merge_head" |
Junio C Hamano | 14e5d40 | 2010-01-17 22:31:38 -0800 | [diff] [blame] | 288 | ;; |
| 289 | esac |
| 290 | eval "exec $eval" |